from collections import OrderedDict

ENSEMBLE_STATE_STARTED = "Starting"
ENSEMBLE_STATE_STOPPED = "Stopped"
ENSEMBLE_STATE_CANCELLED = "Cancelled"
ENSEMBLE_STATE_FAILED = "Failed"
ENSEMBLE_STATE_UNKNOWN = "Unknown"

REALIZATION_STATE_WAITING = "Waiting"
REALIZATION_STATE_PENDING = "Pending"
REALIZATION_STATE_RUNNING = "Running"
REALIZATION_STATE_FAILED = "Failed"
REALIZATION_STATE_FINISHED = "Finished"
REALIZATION_STATE_UNKNOWN = "Unknown"

ALL_REALIZATION_STATES = (
    REALIZATION_STATE_WAITING,
    REALIZATION_STATE_PENDING,
    REALIZATION_STATE_RUNNING,
    REALIZATION_STATE_FAILED,
    REALIZATION_STATE_FINISHED,
    REALIZATION_STATE_UNKNOWN,
)

FORWARD_MODEL_STATE_START = "Pending"
FORWARD_MODEL_STATE_RUNNING = "Running"
FORWARD_MODEL_STATE_FINISHED = "Finished"
FORWARD_MODEL_STATE_FAILURE = "Failed"

COLOR_WAITING = (164, 200, 255)
COLOR_PENDING = (190, 174, 212)
COLOR_RUNNING = (255, 255, 153)
COLOR_FAILED = (255, 200, 200)
COLOR_UNKNOWN = (128, 128, 128)
COLOR_FINISHED = (127, 201, 127)
COLOR_NOT_ACTIVE = (255, 255, 255)


REAL_STATE_TO_COLOR = OrderedDict(
    [
        (REALIZATION_STATE_FINISHED, COLOR_FINISHED),
        (REALIZATION_STATE_FAILED, COLOR_FAILED),
        (REALIZATION_STATE_RUNNING, COLOR_RUNNING),
        (REALIZATION_STATE_PENDING, COLOR_PENDING),
        (REALIZATION_STATE_WAITING, COLOR_WAITING),
        (REALIZATION_STATE_UNKNOWN, COLOR_UNKNOWN),
    ]
)

FORWARD_MODEL_STATE_TO_COLOR = {
    FORWARD_MODEL_STATE_START: COLOR_PENDING,
    FORWARD_MODEL_STATE_RUNNING: COLOR_RUNNING,
    FORWARD_MODEL_STATE_FINISHED: COLOR_FINISHED,
    FORWARD_MODEL_STATE_FAILURE: COLOR_FAILED,
}
